#!/home/bms/.guix-profile/bin/guile \
-e main -s
!#

;; Copyright 2017 Ben Sutter.
;;
;; This file is part of Msg.
;;
;; Msg is free software: you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation, either version 3 of the License, or
;; (at your option) any later version.
;;
;; Msg is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with msg.  If not, see <http://www.gnu.org/licenses/>.

(use-modules (ice-9 getopt-long))

(define (main args)
  (let* ((option-spec '((version (single-char #\v) (value #f))
                        (help    (single-char #\h) (value #f))
                        (license (single-char #\l) (value #f))
                        (username (single-char #\u) (value #t))
                        (server-port (single-char #\p) (value #t))
                        (run-server (single-char #\s) (value #f))
                        (run-client (single-char #\c) (value #f))
                        (server-address (single-char #\a) (value #t))))
         (options (getopt-long args option-spec))
         (help-wanted (option-ref options 'help #f))
         (version-wanted (option-ref options 'version #f))
         (license-wanted (option-ref options 'license #f))
         (username-set (option-ref options 'username "Winston"))
         (port-set (option-ref options 'server-port "1984"))
         (address-set (option-ref options 'server-address "127.0.0.1"))
         (server-wanted (option-ref options 'run-server #f))
         (client-wanted (option-ref options 'run-client #f)))
    (if (or version-wanted help-wanted license-wanted server-wanted client-wanted)
        (begin
          (if version-wanted
              (display "msg version 0.1\n"))
          (if help-wanted
              (display "\
msg [options] \n\
  -v, --version         Display version \n\
  -h, --help            Display this help \n\
  -l, --license         Display the license reminder \n\
  -u, --username        Specify a username \n\
  -a, --server-address  Specify the address of the server to connect to \n\
  -s, --run-server      Runs the server \n\
  -c, --run-client      Runs the client \n\
  -p, --server-port            Specifies the port to connect to or run on \n\
"))
          (if license-wanted
              (display "\
msg \nCopyright (C) 2017  Ben Sutter \n\
This program comes with ABSOLUTELY NO WARRANTY; for details type `/warranty'. \n\
This is free software, and you are welcome to redistribute it \
under certain conditions; type `/conditions' for details. \n\
"))
          (if server-wanted
              (server-runner address-set port-set))
          (if client-wanted
              (client-runner address-set port-set username-set)))
        (begin
          (display "See msg --help for usage details.") (newline)))))
        
(define (server-runner address port)
  (display "Running server.") (newline))

(define (client-runner address port username)
  (display "Running client.") (newline))
